#MAG3_0P357 Patch VIX Deployer

If (-NOT ([Security.Principal.WindowsPrincipal] [Security.Principal.WindowsIdentity]::GetCurrent()).IsInRole([Security.Principal.WindowsBuiltInRole]::Administrator))
{
  #Relaunch as an elevated process:
  Start-Process powershell.exe "-File",('"{0}"' -f $MyInvocation.MyCommand.Path) -Verb RunAs
  exit
}

#Set Global Variables
#$Global:varJavaPath = "C:\Program Files\Java\jre1.8.0_331\lib\"
#$Global:varJavaPath = "C:\Program Files\Java\jre1.8.0_351\lib\"
$Global:varJavaPath = "C:\Program Files\Java\jre1.8.0_371\lib\"
$Global:varWebAppPath = "$($env:CATALINA_HOME)\webapps"
$Global:varDicomWebAppPath = "$($env:CATALINA_HOME)\webapps\DicomImporterWebApp\"
$Global:varROIWebAppPath = "$($env:CATALINA_HOME)\webapps\ROIWebApp\"
$Global:varApachePath = "$($env:CATALINA_HOME)\lib\"
$Global:varUpdatePath = "C:\Temp\P357_JarFiles_Patch"
$Global:varNewJavaPath = "C:\Temp\P357_JarFiles_Patch\lib"
$Global:varNewDicomWebAppPath = "C:\Temp\P357_JarFiles_Patch\DicomImporterWebApp"
$Global:varNewROIWebAppPath = "C:\Temp\P357_JarFiles_Patch\ROIWebApp"
$Global:varNewDicomWebAppZip = "C:\Temp\P357_JarFiles_Patch\DicomImporterWebApp-0.1.zip"
$Global:varNewROIWebAppZip = "C:\Temp\P357_JarFiles_Patch\ROIWebApp-0.1.zip"

# Display Paths to update and ask confirmation to start

Write-Warning "Path for Java location to $($Global:varJavaPath)"
Write-Warning "Path for Apache Tomcat location to $($Global:varApachePath)"
Write-Warning "Path for Updated Java Jar files from $($Global:varNewJavaPath)"
Write-Warning "Path for WebApp Importer Update from $($Global:varNewDicomWebAppPath)"
Write-Warning "Path for WebApp ROI Update from $($Global:varNewROIWebAppPath)"

$tomcatname = "Tomcat9"
#Tomcat State
$tomcatstate = (Get-Service -Name Tomcat9).Status


function zipremove-p357JarFiles{

    $arrFiles = @("CoreRouter-0.1.jar","CoreValueobjects-0.1.jar","DicomServicesDataSourceProvider-0.1.jar","ImagingDicomDCFUtilities-0.1.jar","ImagingDicomRouter-0.1.jar","VistaImagingDataSourceProvider-0.1.jar","VistaStorage-0.1.jar", `
            "ImagingVistaRealm-0.1.jar", "ROICommands-0.1.jar","ROICommon-0.1.jar","ROIVistaImagingDataSourceProvider-0.1.jar")
    $varJarZipFile = Join-Path -Path $Global:varUpdatePath -ChildPath "Jar-P357_Backup.zip"
     
    Write-Host "Zipping files:"
    Write-Host $arrFiles
    Write-Host "In folder $($Global:varApachePath) To Zip File:$($varJarZipFile)"
    Get-ChildItem $Global:varApachePath -Recurse | where { $_.Name -in $arrFiles } | Compress-Archive -DestinationPath $varJarZipFile -Update

    Write-Output "Deleting original Jar files from $($Global:varApachePath)"

    foreach ($varFile in $arrFiles)
    {
        $varFullFilePath = Join-Path -Path $Global:varApachePath -ChildPath $varFile
        if (Test-Path $varFullFilePath) {
            Remove-Item -Path $varFullFilePath
            Write-Output "$($varFullFilePath) has been successfully deleted."
        }else{
            Write-Output "$($varFullFilePath) does not exist."
             }
    }    
 }

function copy-Jarfiles {

     $arrFiles = @("CoreRouter-0.1.jar","CoreValueobjects-0.1.jar","DicomServicesDataSourceProvider-0.1.jar","ImagingDicomDCFUtilities-0.1.jar","ImagingDicomRouter-0.1.jar","VistaImagingDataSourceProvider-0.1.jar","VistaStorage-0.1.jar", `
                    "ImagingVistaRealm-0.1.jar", "ROICommands-0.1.jar","ROICommon-0.1.jar","ROIVistaImagingDataSourceProvider-0.1.jar")

    Write-Output "Copying the Jar files to $($Global:varApachePath)"
    foreach  ($varFile in $arrFiles)
    {
        $varFullFilePath = Join-Path -Path $Global:varNewJavaPath -ChildPath $varFile
            
        Write-Output "Copying $($varFullFilePath) to $($Global:varApachePath)"
        Copy-Item -Path $varFullFilePath -Destination $Global:varApachePath
    }
 }

function backup-WebApp {
    
    $varWebAppBackupPath = "$($Global:varUpdatePath)"
    $varDicomWebAppZipFile = Join-Path -Path $varWebAppBackupPath -ChildPath Backup-DicomImporterWebApp.zip
    $varROIWebAppZipFile = Join-Path -Path $varWebAppBackupPath -ChildPath Backup-ROIWebApp.zip

    Write-Output "Zipping DICOM Importer Web App folder to $($varDicomWebAppZipFile)"
    Compress-Archive -Path $Global:varDicomWebAppPath -DestinationPath $varDicomWebAppZipFile -Force
    Write-Output "Zipping ROI Importer Web App folder to $($varROIWebAppZipFile)"
    Compress-Archive -Path $Global:varROIWebAppPath -DestinationPath $varROIWebAppZipFile -Force

    Write-Output "Deleting files from $($Global:varDicomWebAppPath)"
    Get-ChildItem -Path $varDicomWebAppPath\* | Remove-Item -Force -Recurse
    Write-Output "Deleting files from $($Global:varROIWebAppPath)"
    Get-ChildItem -Path $varROIWebAppPath\* | Remove-Item -Force -Recurse

 }

function unzip-WebAppFiles {

    Write-Host "UnZipping $($Global:varNewDicomWebAppZip) to $($Global:varDicomWebAppPath)"
    Expand-Archive -Path $Global:varNewDicomWebAppZip -DestinationPath $Global:varDicomWebAppPath
    
    Write-Host "UnZipping $($Global:varNewROIWebAppZip) to $($Global:varROIWebAppPath)"
    Expand-Archive -Path $Global:varNewROIWebAppZip -DestinationPath $Global:varROIWebAppPath

 }

function updateVixConfig {
	$XMLfile = 'C:\VixConfig\ViXConfig.xml'
	[XML]$ViXConfigVar = Get-Content $XMLfile
	$CurrentVersion = $ViXConfigVar.SelectSingleNode("//void[@property='vixSoftwareVersion']").string	
	#Backup the existing VixConfig	
	$ViXConfigVar.Save("C:\VixConfig\ViXConfig_DefaultVersion.xml")
	$ViXConfigVar.SelectSingleNode("//void[@property='vixSoftwareVersion']").string = '30.357.1.8304'
	$ViXConfigVar.Save("C:\VixConfig\ViXConfig.xml")
 }
# Display Paths to update and ask confirmation to start

#Write-Warning "Path for Java location to $($Global:varJavaPath)"
#Write-Warning "Path for Apache Tomcat location to $($Global:varApachePath)"
#Write-Warning "Path for Updated Java Jar files to $($Global:varNewJavaPath)"
#Write-Warning "Path for WebApp Update files $($Global:varNewDicomWebAppPath)"

Write-Host "Must Stop the Apache Tomcat Service before running the Script"
$confirmStart = Read-Host "Ready to run script (Y/N)?"

if ($confirmStart -ne "Y") { exit }

if ($tomcatstate -notmatch "Stopped") {
    Write-Host "Apache Tomacat service has not been stopped. Stop the service before running the script"
    exit
    }

# 1)  Zip and remove the Jar files.
Write-Warning "1) Zip and removing the Jar files."
zipremove-p357JarFiles

# 2) Add the updated .jar files
Write-Warning "2) Add the updated .jar files."
copy-Jarfiles

# 3) Backup and Delete Web App folder to Zip file
Write-Warning "3) Backup and Delete Web App folder to Zip file."
backup-WebApp

# 4) UnZip Updated Web App Folder 
Write-Warning "4) Update Web App Folder" 
unzip-WebAppFiles

# 5) Update VIX version
Write-Warning "5) Update VIX version"
updateVixConfig

Write-Warning "P357 Jar and WebApp update patch script complete."