﻿#MAG3_0P357 Patch VIX Restore prior Deployer

If (-NOT ([Security.Principal.WindowsPrincipal] [Security.Principal.WindowsIdentity]::GetCurrent()).IsInRole([Security.Principal.WindowsBuiltInRole]::Administrator))
{
  #Relaunch as an elevated process:
  Start-Process powershell.exe "-File",('"{0}"' -f $MyInvocation.MyCommand.Path) -Verb RunAs
  exit
}

#Set Global Variables
#$Global:varJavaPath = "C:\Program Files\Java\jre1.8.0_331\lib\"
#$Global:varJavaPath = "C:\Program Files\Java\jre1.8.0_351\lib\"
$Global:varJavaPath = "C:\Program Files\Java\jre1.8.0_371\lib\"
$Global:varWebAppPath = "$($env:CATALINA_HOME)\webapps\"
$Global:varROIWebAppPath = "$($env:CATALINA_HOME)\webapps\ROIWebApp\"
$Global:varDicomImporterWebAppPath = "$($env:CATALINA_HOME)\webapps\DicomImporterWebApp\"
$Global:varApachePath = "$($env:CATALINA_HOME)\lib\"
$Global:varUpdatePath = "C:\temp\p357_JarFiles_Patch"
$Global:varNewJavaPath = "C:\temp\p357_JarFiles_Patch\lib"
$Global:varNewJavaZip = "C:\temp\p357_JarFiles_Patch\Jar-P357_Backup.zip"
$Global:varNewWebAppPath = "C:\temp\p357_JarFiles_Patch\DicomImporterWebApp"
$Global:varNewWebAppZip = "C:\temp\p357_JarFiles_Patch\Backup-DicomImporterWebApp.zip"
$Global:varNewROIWebAppPath = "C:\temp\p357_JarFiles_Patch\ROIWebApp"
$Global:varNewROIWebAppZip = "C:\temp\p357_JarFiles_Patch\Backup-ROIWebApp.zip"
# Display Paths to update and ask confirmation to start

Write-Warning "***  Restore P357 VIX Deployer to prior VIX stage!"
Write-Warning "***  Will remove P357 Jar Files from $($Global:varApachePath) Tomcat"
Write-Warning "***  Will restore P357 WebApps Update folders on $($Global:varNewWebAppPath)"

$tomcatname = "Tomcat9"
#Tomcat State
$tomcatstate = (Get-Service -Name Tomcat9).Status


function unzip-BackedUpJarfiles {

    $arrFiles = @("CoreRouter-0.1.jar","CoreValueobjects-0.1.jar","DicomServicesDataSourceProvider-0.1.jar","ImagingDicomDCFUtilities-0.1.jar","ImagingDicomRouter-0.1.jar","VistaImagingDataSourceProvider-0.1.jar","VistaStorage-0.1.jar", `
            "ImagingVistaRealm-0.1.jar", "ROICommands-0.1.jar","ROICommon-0.1.jar","ROIVistaImagingDataSourceProvider-0.1.jar")
    
    Write-Host "Deleting P357 Jar Files from $($Global:varApachePath)"

    foreach ($varFile in $arrFiles)
    {
        $varFullFilePath = Join-Path -Path $Global:varApachePath -ChildPath $varFile
        if (Test-Path $varFullFilePath) {
            Remove-Item -Path $varFullFilePath
            Write-Output "$varFile has been successfully deleted."
        }else{
            Write-Output "$varfile does not exist."
            }
          
    }

        $jarP357Backup = (Get-ChildItem C:\temp\P357_JarFiles_Patch -Filter Jar-P357Backup*.zip | Get-Item).FullName
       
        if ($restoreJar -eq "Y") 
        {

            Write-Host "Unzipping $($jarP357Backup) file."
            Expand-Archive -Path $jarP357Backup -DestinationPath $varApachePath
            }
 
}

function unzip-BackedUpWebAppFiles {

    
    $zipFile = (Get-ChildItem C:\temp\P357_JarFiles_Patch -Filter Backup-DicomImporterWebApp.zip | Get-Item).FullName

    Get-ChildItem -Path $varDicomImporterWebAppPath\* | Remove-Item -Force -Recurse

    Write-Host "UnZipping Importer $($Global:varNewWebAppZip) to $($Global:varWebAppPath)"
    Expand-Archive -Path $Global:varNewWebAppZip -DestinationPath $Global:varWebAppPath -Force


    $zipFile = (Get-ChildItem C:\temp\P357_JarFiles_Patch -Filter Backup-ROIWebApp.zip | Get-Item).FullName

    Get-ChildItem -Path $varROIWebAppPath\* | Remove-Item -Force -Recurse

    Write-Host "UnZipping ROI $($Global:varNewROIWebAppZip) to $($Global:varWebAppPath)"
    Expand-Archive -Path $Global:varNewROIWebAppZip -DestinationPath $Global:varWebAppPath -Force
                         
 }


# Display Paths to update and ask confirmation to start

Write-Warning "Path for Apache Tomcat location to $($Global:varApachePath)"
Write-Warning "Path for restored Java ZIP files from $($Global:varNewJavaZip)"
Write-Warning "Path for restored WebApp Importer ZIP files $($Global:varNewWebAppZip)"
Write-Warning "Path for restored WebApp ROI ZIP files $($Global:varNewROIWebAppZip)"

Write-Host " Stop the Apache Tomcat Service before running the Script"
$confirmStart = Read-Host "Ready to run script (Y/N)?"

if ($confirmStart -ne "Y") { exit }

if ($tomcatstate -notmatch "Stopped") {
    Write-Host "Apache TomaCat service has not been stopped. Stop the service before running the script"
    exit
    }

# 1) Unzip and restore jar files
Write-Warning "1) Unzip and restore the Jar files."
unzip-BackedUpJarfiles

# 2) UnZip and restore Web App Folder
Write-Warning "2) Unzip and restore WebApp files."
unzip-BackedUpWebAppFiles

Write-Warning "P357 Jar and WebApp Restore patch script complete."